import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "moebius92.SkillData";

MainWindowWidth=200;
MainWindowHeight=49;
MaxTarget=1;

HunterSkill={};
quickslots={}

LazyWindow = class(Turbine.UI.Window);
function LazyWindow:Constructor()
	Turbine.UI.Window.Constructor( self );

	self.settings = LazySkillLoadSettings();

	self:SetSize(MainWindowWidth,MainWindowHeight);
	self:SetPosition( self.settings.x, self.settings.y );
	self:SetOpacity(0.85);
	self:SetBackColor(Turbine.UI.Color(0.3,0.3,0.3));

	self.dragging = false;
	self.move = true;
	self.player = Turbine.Gameplay.LocalPlayer.GetInstance();

	self.Timebutton = {}
	self.Target = {}
	self.SelectTarget ={}
	
	self.player.InCombatChanged = function (sender,args)
		if self.cm then
			if self.player:IsInCombat() == true then
				if not self.running then
					self.running = true;
					time = Turbine.Engine.GetGameTime();
					self.Endtime = time + self.Remaintime ;
					self:SetWantsUpdates(true);
				end
			else
				if self.running then
					self.running = false;
					self:SetWantsUpdates(true);
					self:ResetTimer();
				end
			end
		end
	end
	
	quickslot=Turbine.UI.Lotro.Quickslot();
	quickslot:SetParent(self);
	quickslot:SetSize(36,36);	
	quickslot:SetPosition(5,5);
	quickslot:SetAllowDrop(true); 

	for i=1,4 do
		quickslots[i]=Turbine.UI.Lotro.Quickslot();
		quickslots[i]:SetParent(self);
		quickslots[i]:SetSize(36,36);	
		quickslots[i]:SetPosition(20+i*34,5);
		if self.settings.skill[i] then
			quickslots[i]:SetShortcut(Turbine.UI.Lotro.Shortcut(6, settings.skill[i]))
		end
		
		quickslots[i]:SetAllowDrop(true); 

		quickslots[i].MouseClick = function(sender, args)
			if args.Button == Turbine.UI.MouseButton.Right then
				sender:SetShortcut(Turbine.UI.Lotro.Shortcut(0, ""));
			end
		end
		quickslots[i].DragDrop = function(sender, args)
			if sender:GetShortcut():GetType() == 6 then
				self:updateSkills();
				self:SaveSettings();
			else
				sender:SetShortcut(Turbine.UI.Lotro.Shortcut(0, ""));
			end
		end

	end

	self:updateSkills();

	self:SetWantsUpdates(true);

	
end

function LazyWindow:updateSkills()
	local askills = Turbine.Gameplay.LocalPlayer:GetInstance():GetTrainedSkills();
	for i = 1, askills:GetCount(), 1 do
		for j=1,4 do
			if quickslots[j]:GetShortcut() and quickslots[j]:GetShortcut():GetType() == 6 then
				local name = moebius92.SkillData.shortcut[quickslots[j]:GetShortcut():GetData()];
				if tostring(askills:GetItem(i):GetSkillInfo():GetName()) == name then
					HunterSkill[j]=askills:GetItem(i);
					self.settings.skill[j] = quickslots[j]:GetShortcut():GetData();
				end
			end
		end
	end
end


function LazyWindow:MouseDown(args)
	if args.Button == Turbine.UI.MouseButton.Left and self.move then
		self.dragStartX = args.X;
		self.dragStartY = args.Y;
		self.dragging = true;
	end
end

function LazyWindow:MouseMove(args)

	if self.dragging then
		local x, y = self:GetPosition();
		x = x + (args.X - self.dragStartX);
		y = y + (args.Y - self.dragStartY);
		settings.x = x;
		settings.y = y;
		self:SetPosition(x, y);
	end
end

function LazyWindow:MouseUp(args)
	if args.Button == Turbine.UI.MouseButton.Left then
		self:SaveSettings();
		self.dragging = false;
	end
end

function LazyWindow:Update()
	self:SetWantsUpdates(true);
	for i=1,4 do
		if HunterSkill[i] and HunterSkill[i]:IsUsable() and HunterSkill[i]:GetResetTime() == -1 then
			quickslot:SetShortcut(quickslots[i]:GetShortcut());
			return
		end
	end
end

function LazyWindow:MouseClick(args)
	if args.Button == Turbine.UI.MouseButton.Right then
		self.running=false;
		self:SetWantsUpdates(true);
		self:SetVisible(false);
		self:SaveSettings();
		self:Close();
	end
end

function LazySkillLoadSettings()
	settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "Lazyskill" );
	if type( settings ) ~= "table" then
		settings={ };
	end
	if (not settings.x) then settings.x = 400; end
	if (not settings.y) then settings.y = 400; end
	if (not settings.dur) then settings.dur = 60; end
	if (settings.cm == nil) then settings.cm = true; end
	if (not settings.skill) then settings.skill = {} end
	
	return settings;
end

function LazyWindow:SaveSettings()
	Turbine.PluginData.Save( Turbine.DataScope.Character, "Lazyskill", self.settings );
end


